<?php
// Berylium Objects http-engine
//2002-07-12 01:16

/* Copyright 2001, 2002 by Chris Snyder

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

//set-up debug
$debug= $_GET['debug'];

  
// $beryliumroot is set in the berylium/http/berylium script
include("$beryliumroot/code/berylium-functions.php");
include("$beryliumroot/code/berylium-classes.php");


// init timer
$timerStart= bgetmicrotime();


// start a new Session
// the session loads from the db (or creates and saves new...), creates a session->request, a session->member (authenticated if not anonymous), and starts a new error channel
$session= new Session;
$timenow= bgetmicrotime() - $timerStart;


// debug prefs
if ($debug=="1") {
  $session->p_debug= "1";
  berror("Setting session->p_debug=$session->p_debug.",1);
  }
elseif ($debug=="off") {
  $debug= "";
  $session->p_debug= "";
  berror("Resetting session->p_debug ($session->p_debug)",1);
  }
$session->setErrorLevel();  

// role prefs
$role= $_GET['role'];
if ($role!="" && $role!="0") {
  $session->p_role= $role;
  berror("Setting session->p_role=$session->p_role.",1);
  }
elseif ($role=="0") {
  $session->p_role= "";
  berror("Resetting session->p_role ($session->p_role)",1);
  }

// standardContext prefs
$standardContext= $_GET['standardContext'];
if ($standardContext!="" && $standardContext!="0") {
  $session->p_standardContext= 1;
  berror("Setting session->p_standardContext=$session->p_standardContext.",1);
  }
elseif ($standardContext=="0") {
  $session->p_standardContext= "";
  berror("Resetting session->p_standardContext ($session->p_standardContext)",1);
  }
  
//showDeleted prefs (only for editors or admins, really...)
$showDel= $_GET['showDeleted'];
if ($showDel!="" && $showDel!="0") {
  $session->p_showDeleted= 1;
  berror("Setting session->p_showDeleted ($session->p_showDeleted).",1);
  }
elseif ($showDel=="0") {
  $session->p_showDeleted= "";
  berror("Resetting session->p_showDeleted ($session->p_showDeleted)",1);
  }

  
// write session prefs
$session->updateObject();

// read from session prefs...
if ($session->p_debug==1) {
  $debug= 1;
  }
else $debug= "";

if ($session->p_role!="") {
  $role= $session->p_role;
  }
else $role= "";
berror("** Debug=$debug and Role=$session->p_role and standardContext=$session->standardContext for this request. session->p_debug=$session->p_debug.",1);

berror("<hr>Session construction complete at $timenow. Loading member next.<hr>",1);


// get the site
$site= new Site;
$site->loadSite();
$session->siteid= $site->id;
$timenow= bgetmicrotime() - $timerStart;
berror("<hr>Site construction complete at $timenow. Loading sitemember next.<hr>",1);


// get the sitemember
//$member->id= 1;
$sitemember= new Sitemember;
$sitemember->getsitemember();
if ($sitemember->id!="") $sitemember->getBaseUrl();

	//allow some sitemembers to drop rank dynamically
	switch ($sitemember->role) {
		case "admin":
			if ($role) {
				$sitemember->role= $role;
				$sitemember->truerole= "admin";
				}
			break;
		case "editor":
			if ($role=="writer" || $role=="member" || $role=="anonymous") {
				$sitemember->role= $role;
				$sitemember->truerole= "editor";
				}
			break;
		case "writer":
			if ($role=="member" || $role=="anonymous") {
				$sitemember->role= $role;
				$sitemember->truerole= "editor";
				}
			break;
		}
	if ($sitemember->truerole=="") {
		$sitemember->truerole= $sitemember->role;
		berror("Sitemember did not drop role.",1);
		}
	else {
		berror("Sitemember dropped role from $sitemember->truerole to $sitemember->role.",1);
		}
$timenow= bgetmicrotime() - $timerStart;
berror("<hr>sitemember construction complete at $timenow. Loading member next, unless anonymous, then loading folder.<hr>",1);

// load member if not anonymous
if ($sitemember->truerole!="anonymous") {
        $member= new Member;
        $query= "SELECT * FROM member WHERE id='$session->memberid' AND status!='delete' ";
        $member->selectObject($query);
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr>member construction complete ($member->email) at $timenow. Loading session policy next.<hr>",1);
        }

// get session->policy here
$session->applyPolicy();
$timenow= bgetmicrotime() - $timerStart;
berror("<hr>Session policy discovery complete at $timenow. Loading folder next.<hr>",1);

// get the folder for folderid
$folder= new Folder;
$folder->loadFolder();
$session->folderid= $folder->id;
$timenow= bgetmicrotime() - $timerStart;
berror("<hr>Folder construction complete at $timenow. Loading primary object next.<hr>",1);

// containers, then site and folder context lookup were here, now moved below object lookup...

// preprocess was here, along with css and folder header, now moved below object lookup...

// deal with the primary object
// instantiate the proper class
$command= "\$object= new ".ucfirst($session->request->objtype).";";
eval($command);

// set-up the name
$object->name= $session->request->objectname;
$object->folderid= $folder->id;
if ($session->request->method=="save" OR $session->request->method=="savenew") {
        $session->archMethod= "save";
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr> Will save primary '$object->objtype' object (#$object->id)/($object->name) here, from folderid #$object->folderid. Time is $timenow.<hr>",1);
        }
else {
        $session->archMethod= "view";
        $object->lookup();
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr> Loaded primary '$object->objtype' object (#$object->id)/($object->name) here, from folderid #$object->folderid. Time is $timenow.<hr>",1);
        }

        
// now look for cache if anonymous view of document or folder and not standardContexts
if ($sitemember->truerole=="anonymous" && !$session->p_standardContext && $session->request->method=="view" && ($session->request->objtype=="document" || $session->request->objtype=="folder")) {
        // anonymous and method=view, objtype=document or folder, so look for cache
        $session->cacheFile= $beryliumroot."/files/".$site->name."/.cache/".$object->objtype."-".$object->id.".".$session->request->format;
        berror("Looking for cache at $session->cacheFile",1);
        if (@file_exists($session->cacheFile) && $_GET['recache']!=1) {
                // is it fresh? (60 seconds)
                $cachestamp= filemtime($session->cacheFile);
                if (time() < ($cachestamp + 60)) {
                        $session->cached= 1;
                        berror("Found fresh cachefile, will serve it.",1);
                        }
                else {
                        $session->cached= 2;
                        berror("Found cachefile but it is out of date (mtime > 60 seconds).",1);
                        }
                }
        else {
                $session->cached= 2;
                berror("Not found (or recache=1 ($_GET[recache])), will create one on output.",1);
                }
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr>Done looking for cached ".$session->request->objtype." ".$session->request->method.". (session->cache:$session->cached) Time is $timenow.<hr>",1);        
        }
        
// only do the big render thing if no cache is found
if ($session->cached!=1) {
        // get the containers
        $containers= $session->getContainers($folder);
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr>Containers construction complete at $timenow. Rendering Object next.<hr>",1);
        
        // render object view or perform object save
        if ($session->archMethod=="save") {
                $object->save();
                }
        else $object->view();
        //turn off caching if no context found. 
        if ($object->nocontext==1) $session->cached= "";
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr>Object rendering finished at $timenow. Getting site and folder contexts now.<hr>",1);
        
        //get site and folder contexts
        $site->getContext("view",$session->request->format);
        $folder->getContext("view",$session->request->format);
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr>Site and folder contexts found at $timenow. Rendering site and folder now.<hr>",1);
        
        // preprocess site and folder
        $site->preProcess();
        $folder->preProcess();
        
        // render site css, folder css, and folder headers
        $site->css($session);
        $folder->css($session);
        $folder->header($session);
        
        // render folder and site footers
        $folder->footer($session);
        $site->footer($session);
        
        // render site header (last so it includes all css and $object properties...)
        $site->header($session);
        
        // postprocess folder and site
        $folder->postProcess();
        $site->postProcess();
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr>All objects rendered at $timenow. Outputting.<hr>",1);
        
        // print session->output
        ksort($session->output);
        
        // if were making a cache, open the file
        if ($session->cached==2) {
                $fp= @fopen($session->cacheFile,"w");
                if (!$fp) {
                        // bwaaa, can't open cache file!
                        $session->cached= 0;
                        berror("Bzzt, can't open cachefile at $session->cacheFile. Something is amiss.",1);
                        }
                }
        
        foreach($session->output as $key=>$value) {
                berror("Outputting chunk $key now.",1);
                if ($session->netscape) {
                    // Netscape 4 doesn't render single quote entities, other browsers might not either. sigh.
                    $value= str_replace("&rsquo;", "'", $value);
                    //$value= str_replace("border=0", "border=1", $value);
                    }
                print $value;
                
                if ($session->cached==2) {
                        // append value to cache file
                        fwrite($fp,$value);
                        berror("Writing chunk $key to cachefile ($fp) now.",1);
                        }
                }
        flush();
        
        // close cachefile if open
        if ($session->cached==2) {
                $fp= fclose($fp);
                berror("Wrote cachefile to $session->cacheFile.",1);
                }
                
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr>Output done at $timenow. Cleaning up.<hr>",1);
        }
else {
        // output the cache file
        readfile($session->cacheFile);
        flush();
        $timenow= bgetmicrotime() - $timerStart;
        berror("<hr>Cache output done at $timenow. Cleaning up.<hr>",1);
        }


// log session
berror("About to update session, give yourselves a hand. session->p_debug=$session->p_debug, debug=$debug.",1);
$session->updateObject();


// print session->error then exit
if ($session->p_debug=="1") {
	print "<table bgcolor='#ffffff'><tr><td>";
	print "<hr><b>\$session->error</b> for berylium server at ".$_SERVER["SCRIPT_FILENAME"].". <a href='$session->refreshURL&debug=off'>Turn off debug</a>.";
	print "<blockquote>";
	print nl2br(bparsebml($session->error));
	
	if ($_REQUEST["vars"]) {

		// session
		print "<hr>";
		$sessionarray= get_object_vars($session);
		print "<blockquote><b>session:</b>";
		foreach ($sessionarray as $key => $val) {
		if ($key=="error" || $key=="output" ) continue;
			print "<br>$key=>$val";
			}
		print "</blockquote>";

		// session->request
		print "<hr>";
		$request= $session->request;
		$sessionrequestarray= get_object_vars($request);
		print "<blockquote><b>session->request:</b>";
		foreach ($sessionrequestarray as $key => $val) {
		if ($key=="error" || $key=="output" ) continue;
			print "<br>$key=>$val";
			}
		print "</blockquote>";
		
		print "<hr>";
		$preferences= $session->preferences;
		$sessionpreferencesarray= get_object_vars($preferences);
		print "<blockquote><b>session->preferences:</b>";
		foreach ($sessionpreferencesarray as $key => $val) {
		if ($key=="error" || $key=="output" ) continue;
			print "<br>$key=>$val";
			}
		print "</blockquote>";
				
		print "<hr>";
		$sitearray= get_object_vars($site);
		print "<blockquote><b>site:</b>";
		foreach ($sitearray as $key => $val) {
		if ($key=="error" || $key=="output" ) continue;
			print "<br>$key=>$val";
			}
		print "</blockquote>";
		
		print "<hr>";
		$memberarray= get_object_vars($member);
		print "<blockquote><b>member:</b>";
		foreach ($memberarray as $key => $val) {
		if ($key=="error" || $key=="output" ) continue;
			print "<br>$key=>$val";
			}
		print "</blockquote>";
		
		print "<hr>";
		$folderarray= get_object_vars($folder);
		print "<blockquote><b>folder:</b>";
		foreach ($folderarray as $key => $val) {
		if ($key=="error" || $key=="output" ) continue;
			print "<br>$key=>$val";
			}
		print "</blockquote>";
		
		print "<hr>";
		$sitememberarray= get_object_vars($sitemember);
		print "<blockquote><b>sitemember:</b>";
		foreach ($sitememberarray as $key => $val) {
		if ($key=="error" || $key=="output" ) continue;
			print "<br>$key=>$val";
			}
		print "</blockquote>";
		
		print "<hr>";
		print "<blockquote><b>containers[0]:</b>";
		foreach ($containers[0] as $key => $val) {
		if ($key=="error" || $key=="output" ) continue;
			print "<br>$key=>$val";
			}
		print "</blockquote>";
		
		print "<hr>";
		$objectarray= get_object_vars($object);
		print "<blockquote><b>Object:</b>";
		foreach ($objectarray as $key => $val) {
			//if ($key=="error" || $key=="output" ) continue;
			$val= htmlentities($val);
			print "<br>$key=>$val";
			}		
		print "</blockquote>";

		print "<hr>";
		$contextarray= get_object_vars($object->context);
		print "<blockquote><b>context:</b>";
		foreach ($contextarray as $key => $val) {
			//if ($key=="error" || $key=="output" ) continue;
			$val= htmlentities($val);
			print "<br>$key=>$val";
			}		
		print "</blockquote>";		
		}

	print "</blockquote>";
	print "<hr>Session complete at ".date("Y-M-d H:i:s").".<br><a href='$session->refreshURL'>Refresh</a> ($session->refreshURL) | <a href='#top'>Top</a>";
	print "</tr></td></table>";
	}

if ($_REQUEST["info"]) {
	print "<hr><br>";
	phpinfo();
	}

// timer function
$timerEnd= bgetmicrotime();
$timer= $timerEnd - $timerStart;
print "
  <br>
  <table class='bodytable' align='center'>
    <tr>
      <!-- <td align=center valign=middle bgcolor='#ffffff'><a href='http://berylium.org/'><img src='http://berylium.org/berylium/dev/artwork/image-berylium-logo-24x24.png' border=0></a></td> -->
      <td>";
if ($session->request->format=="html" && $session->userAgent!="berylium-wget") {
        if ($session->cached==1) $cacheMessage= "(cached)";
        print "
  <tt>
  Rendered by <a href='http://berylium.org/'>berylium</a> in ".round($timer,3)." seconds $cacheMessage for $session->clientip.</tt>";
        }
elseif ($session->request->format=="html") print "
  <tt>
  Rendered by <a href='http://berylium.org/'>berylium</a>: ".date("Y-M-d H:i:s").".</tt>";
if ($sitemember->role=="editor" OR $sitemember->role=="admin" AND !$session->p_standardContext) {
  print "<tt><br>Editor: <a href='$session->refreshURL&standardContext=1'>use standard contexts</a></tt>";
  }
elseif ($session->p_standardContext) {
  print "<tt><br><a href='$session->refreshURL&standardContext=0'>use per-site contexts</a></tt>";
  }
if ($sitemember->role!=$sitemember->truerole) {
  print "<tt><br>Your true role is $sitemember->truerole. <a href='$session->refreshURL&role=0'>resume that role</a></tt>";
  }
if ($session->p_debug) {
  print "<tt><br><a href='$session->refreshURL&debug=off'>turn off debug</a></tt>";
  }
elseif ($sitemember->role=="editor" OR $sitemember->role=="admin") {
  print "<tt><br>Switch to <a href='$session->refreshURL&debug=1'>debug mode</a></tt>";
  }
if ($session->netscape) {
  print "<tt><br>If this page looks ugly, we encourage you to upgrade your browser.<br>
        Detected $session->userAgent.</tt>";
  }
print "</td>
    </tr>
  </table>";
?>
